<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en">
<head>
	<title>CarbonPHP Documentation</title>
	<style type="text/css">
		* {
			margin: 0;
			padding: 0;
		}

		html {
			font-family: "Lucida Sans Unicode", "Lucida Grande";
			font-size: 14px;
		}

		body {
			background: #fff;
			color: #666;
		}

		h1 {
			font-size: 15px;
			font-weight: bold;
			margin-bottom: 5px;
		}

		ol, ul {
			margin: 10px 0 10px 0;
			list-style-position: inside;
		}

		p {
			margin: 5px 0 5px 0;
		}

		.content {
			border: 1px dotted #444;
			margin: 10px;
			padding: 10px;
			text-align: justify;
			width: 700px;
		}

		.example {
			border: 1px solid #ccc;
			background: #eee;
			margin: 10px;
			padding: 10px;
		}
	</style>
</head>

<body>
	<div class="content">
		<h1>CarbonPHP URLs</h1>

		<p>The URLs in CarbonPHP are similar to URLs that can be created using Apache's <i>mod_rewrite</i>.
		CarbonPHP doesn't use the standard 'query string' URLs, CarbonPHP uses a segment-based method. <i>Note</i>:
		you can still enable query string style URLs.  This is shown below.</p>

		<div class="example">
			www.your-domain.com/index.php/<b>shop</b>/<b>product</b>/<b>123</b>
		</div>
	</div>

	<div class="content">
		<h1>URI Segments</h1>

		<p>The URL segments in CarbonPHP follow the approach commonly found in model-view-controller frameworks.</p>

		<div class="example">
			www.your-domain.com/index.php/<b>class</b>/<b>method</b>/<b>id</b>
		</div>

		<ol>
			<li>The first segment is the controller class that is being invoked.</li>
			<li>The second segment is the method of the class invoked.</li>
			<li>The third, and additional segments are any additional parameters you wish to pass.</li>
		</ol>

		<p>The URI class library and URL utility contain functions and methods that make working with CarbonPHP URLs
		easier.</p>
	</div>

	<div class="content">
		<h1>Removing the index.php From the URL</h1>

		<p>CarbonPHP will by default include the <b>index.php</b> in the URL.</p>

		<div class="example">
			www.your-domain.com/<b>index.php</b>/blog/post/1
		</div>

		<p>This can be removed easily using Apache's <i>mod_rewrite</i>.  Below is a simple example using a
		<i>.htaccess</i> file.</p>

		<div class="example">
			RewriteEngine on<br />
			RewriteCond $1 !^(index\.php|images|robots\.txt)<br />
			RewriteRule ^(*.)$ /index.php/$1 [L]
		</div>

		<p>The above example takes any HTTP request other than those for index.php, images, and robots.txt as a
		request for the index.php file.</p>
	</div>

	<div class="content">
		<h1>Adding a Suffix to the URL</h1>

		<p>In the configuration file <b>config/config.php</b> you can tell CarbonPHP a suffix that it will add to any
		generated URLs.</p>

		<div class="example">
			www.your-domain.com/index.php/blog/post/1
		</div>

		<p>Using the example suffix <i>.html</i>, you can make the page appear to be of a certain document type.</p>

		<div class="example">
			www.your-domain.com/index.php/blog/post/1.html
		</div>
	</div>

	<div class="content">
		<h1>Enabling Query Strings</h1>

		<p>If you prefer using query strings, CarbonPHP gives you the option of enabling them.</p>

		<div class="example">
			www.your-domain.com/index.php?c=blog&amp;m=post&amp;id=1
		</div>

		<p>This capability can be enabled by turning it on in the <b>config/config.php</b>.  In the configuration
		file you will see the items below.</p>

		<div class="example">
			$config['use_query_strings'] = false;<br />
			$config['controller_trigger'] = 'c';<br />
			$config['method_trigger'] = 'm';
		</div>

		<p>Changing the 'use_query_strings' to <b>true</b> will enable query string URLs.  Your controllers and
		methods are now accessible using the triggers specified in the configuration file.</p>

		<div class="example">
			www.your-domain.com/index.php?<b>c</b>=controller&amp;<b>m</b>=method
		</div>

		<p><i>Note</i>: If you're using query strings in your URLs you will not be able to use the URL utilities, and
		you will have to build your own URLs.  This is because they are designed to be used with the segment-based
		URLs CarbonPHP natively uses.</p>
	</div>
</body>

</html>
